﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls.DragDrop;
using System.Windows.Media;

namespace RadDragAndDropGettingStartedTTv
{
    public partial class MainPage : UserControl
    {
        private ObservableCollection<ApplicationInfo> allApplications = GenerateApplicationInfos();
        private ObservableCollection<ApplicationInfo> myApplications = new ObservableCollection<ApplicationInfo>();

        public MainPage()
        {
            InitializeComponent();

            allApplicationsBox.ItemsSource = allApplications;
            myApplicationsBox.ItemsSource = myApplications;

            RadDragAndDropManager.AddDragQueryHandler(this, OnDragQuery);
            RadDragAndDropManager.AddDragInfoHandler(this, OnDragInfo);
            RadDragAndDropManager.AddDropQueryHandler(this, OnDropQuery);
            RadDragAndDropManager.AddDropInfoHandler(this, OnDropInfo);
        }
        public static ObservableCollection<ApplicationInfo> GenerateApplicationInfos()
        {
            ObservableCollection<ApplicationInfo> data = new ObservableCollection<ApplicationInfo>();
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/Atom.png", "C.E.R.N.", "Large Collider"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/Brush.png", "Imagine Inc.", "Paintbrush"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/CalendarEvents.png", "Control AG", "Lively Calendar"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/CDBurn.png", "The CD Factory", "Fire Burning ROM"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/favorites.png", "Star Factory", "Fav Explorer"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/Connected.png", "Open Org", "IE Fox"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/ChartDot.png", "AA-AZ inc", "Charting"));
            data.Add(new ApplicationInfo("/RadDragAndDropGettingStartedTTv;component/Images/Games.png", "EB Games", "SuperPlay"));
            return data;
        }

        private void OnDragQuery(object sender, DragDropQueryEventArgs e)
        {
            ListBoxItem listBoxItem = e.Options.Source as ListBoxItem;
            ListBox box = ItemsControl.ItemsControlFromItemContainer(listBoxItem) as ListBox;
            if (e.Options.Status == DragStatus.DragQuery && box != null)
            {
                e.Options.Payload = box.SelectedItem;
                ContentControl cue = new ContentControl();
                cue.ContentTemplate = this.Resources["ApplicationDragTemplate"] as DataTemplate;
                cue.Content = box.SelectedItem;
                e.Options.DragCue = cue;
                e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();
                e.Options.ArrowCue.Background = new SolidColorBrush(Colors.Red);

            }

            e.QueryResult = true;
        }

        private void OnDragInfo(object sender, DragDropEventArgs e)
        {
            ListBoxItem listBoxItem = e.Options.Source as ListBoxItem;
            ListBox box = ItemsControl.ItemsControlFromItemContainer(listBoxItem) as ListBox;
            IList<ApplicationInfo> itemsSource = box.ItemsSource as IList<ApplicationInfo>;
            ApplicationInfo payload = e.Options.Payload as ApplicationInfo;
            if (e.Options.Status == DragStatus.DragComplete)
            {
                if (payload != null && itemsSource.Contains(payload))
                {
                    itemsSource.Remove(payload);
                }
            }
        }

        private void OnDropQuery(object sender, DragDropQueryEventArgs e)
        {
            ItemsControl box = e.Options.Destination as ItemsControl;
            IList<ApplicationInfo> itemsSource = box.ItemsSource as IList<ApplicationInfo>;
            ApplicationInfo payload = e.Options.Payload as ApplicationInfo;
            e.QueryResult = payload != null && !itemsSource.Contains(payload);
        }

        private void OnDropInfo(object sender, DragDropEventArgs e)
        {
            ItemsControl box = e.Options.Destination as ItemsControl;
            IList<ApplicationInfo> itemsSource = box.ItemsSource as IList<ApplicationInfo>;
            ApplicationInfo payload = e.Options.Payload as ApplicationInfo;
            if (e.Options.Status == DragStatus.DropComplete)
                if (!itemsSource.Contains(payload))
                    itemsSource.Add(payload);
        }
    }
}
